package jiaowuxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong"
	"shylinux.com/x/education/src/jiaowuxitong/model"
)

type portal struct {
	gonganxitong.Portal
	user        gonganxitong.User
	userClass   userClass
	Class       Class
	school      school
	list        string `name:"list class_uid index uid auto" role:"void"`
	classCreate string `name:"classCreate school_uid* grade* name*" role:"void"`
	classRemove string `name:"classRemove class_uid*" role:"void"`
}

func (s portal) Inputs(m *ice.Message, arg ...string) {
	s.Class.Inputs(m, arg...)
}
func (s portal) List(m *ice.Message, arg ...string) {
	if len(arg) == 0 {
		m.Cmdy(s.userClass, s.userClass.MyClass, s.user.UserUID(m)).Action(s.ClassCreate).PushAction(s.ClassRemove)
		kit.If(m.Length() == 0, func() { m.EchoInfoButton(m.Trans("Please Create Your Class", "请创建班级"), s.ClassCreate) })
		m.Display("").DisplayCSS("")
	} else {
		s.Portal.List(m, arg...)
	}
}
func (s portal) ClassCreate(m *ice.Message, arg ...string) {
	m.ToastProcess()
	msg := m.Cmd(s.school, s.school.Select, model.UID, m.Option(model.SCHOOL_UID))
	if !m.WarnNotFound(msg.Length() == 0, "school") {
		if !m.Cmdy(s.Class, s.Class.Create, arg).IsErr() {
			args := kit.Simple(model.USER_UID, s.user.UserUID(m), model.CLASS_UID, m.Result())
			m.Cmd(s.userClass, s.userClass.Create, args)
			m.Event(EVENT_CLASS_CREATE, args, model.CLASS_NAME, m.Option(mdb.NAME))
			m.ProcessRefresh().ToastSuccess()
		}
	}
}
func (s portal) ClassRemove(m *ice.Message, arg ...string) {
	m.ToastProcess()
	args := kit.Simple(model.USER_UID, s.user.UserUID(m), m.OptionSimple(model.CLASS_UID))
	msg := m.Cmd(s.userClass, s.userClass.Select, args)
	if !m.WarnNotFound(msg.Length() == 0, "class") {
		m.Cmdy(s.userClass, s.userClass.Delete, args)
		m.Cmdy(s.Class, s.Class.Delete, model.UID, m.Option(model.CLASS_UID))
		m.Event(EVENT_CLASS_REMOVE, args)
		m.ProcessRefresh().ToastSuccess()
	}

}

func init() { ice.Cmd(prefixKey(), portal{}) }

func (s portal) Show(m *ice.Message, arg ...string) {
	cmd := m.GetCommand()
	m.Cmd(s, s.Create, mdb.NAME, cmd.Help, mdb.ICONS, cmd.Icon, ctx.INDEX, m.PrefixKey())
}
